:
:Auto-formatting SDCard to Internal and SDCard storage
:Version 2.0
:Create script by Octanium (Octanium91 on XDA)
:
@echo off
set "title_s=Auto-formatting SDCard to Internal and SDCard storage"
title=%title_s%
echo Loading...
set "rondo=1000"
set "rondo_now=0"
:st_script
cls
echo Loading...
set "lop=100"
set "lop_start=0"
cd /d "%~dp0"
set "adbexecut=%~dp0adb\win\adb.exe"
"%adbexecut%" kill-server
:user_menu
cls
echo.
echo  %title_s%
echo.
echo   Supported devices with Android Marshmallow and higher.
echo   Ensure USB debugging is enabled
echo   -- Attention! You will lose all data on the memory card! --
echo.
echo   Select the formatting mode:
echo  1 - Internal [==--------] SDCard
echo  2 - Internal [=====-----] SDCard
echo  3 - Internal [========--] SDCard
echo  4 - Custom
echo.
set /p "begin="
if "%begin%" == "1" set "smmix=75"&goto st_beg
if "%begin%" == "2" set "smmix=50"&goto st_beg
if "%begin%" == "3" set "smmix=25"&goto st_beg
if "%begin%" == "4" goto set_custom
goto user_menu
:st_beg
cls
echo.
echo  %title_s%
echo.
echo.
echo - Start ADB Server...
for /f "tokens=*" %%a in ('"%adbexecut%" start-server') do set "null=%%a"
:verify_d
cls
echo.
echo  %title_s%
echo.
echo - Start ADB Server...
echo - Connect to device...
if %lop_start% == %lop% goto erfinish
set /a "lop_start = lop_start + 1"
for /f "tokens=*" %%a in ('"%adbexecut%" shell getprop ro.product.model') do set "devmodel=%%a"
if "%devmodel%" == "" goto verify_d
:verify_ok
cls
echo.
echo  %title_s%
echo.
echo - Start ADB Server...
echo - Connect to device...
set /a "rondo_now=rondo_now+1"
if "%rondo_now%" == "%rondo%" goto erfinish
echo - Device: %devmodel%

for /f "tokens=*" %%a in ('"%adbexecut%" shell sm list-disks adoptable') do set "devdisksinf=%%a"

if "%devdisksinf%" == "" goto sdcardnon_error
echo - Formatting %devdisksinf%...
"%adbexecut%" shell sm partition %devdisksinf% mixed %smmix%

:finish
echo - Kill ADB Server...
"%adbexecut%" kill-server
goto done

:done
echo.
echo - Done =) -
echo.
pause
exit

:erfinish
echo - Kill ADB Server...
"%adbexecut%" kill-server
echo  [ERROR] error: device not found
echo.
echo - Done, error =( -
echo.
pause
exit

:sdcardnon_error
echo - Kill ADB Server...
"%adbexecut%" kill-server
echo  [ERROR] SDCard not found!
echo.
echo.
echo - Done, error =( -
echo.
pause
exit

:set_custom
cls
echo.
echo  %title_s%
echo.
echo   Indicate the percentage memory for SDCard partition
echo   Please specify number from 0 to 90
echo.
set /p "smmix="
if "%smmix%" gtr "90" echo Incorrect data! Specify a number less than 90!&timeout 3&goto set_custom
goto st_beg
